#!/usr/bin/env python

class A:
    def a(self):
        return self.x   # x not defined in this class, provided in subclasses

class B(A):
    x = 123             # x provided here

class C(A):
    def __init__(self, x):
        self.x = x      # x provided here

b = B()
c = C(456)

p = b.a()
q = c.a()

result_123 = p
result_456 = q

# vim: tabstop=4 expandtab shiftwidth=4
